unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  public
   {Procedure servant  crer un nouvelle toile}
    procedure NouvelleEtoile( Index :Integer );
   {Procedure servant  crer un nouvelle toile}
    procedure AfficherLesEtoiles;
  end;

{******************************************************************************}
{                      Constantes, Type pour le StarField                      }
{******************************************************************************}
{Constante utilie pour le StarField}
Const
     MAX_ETOILE = 100;  {Nombre d'toiles maximum}
     VITESSE_MAX = 8;  {Vitesse maximal}
     VITESSE_MIN = 1;   {Vitesse minimum}

{Type TStarField3D, contenant 5 proprites pour chaques toiles de notre
 Starfield}
Type
    TStarFiel3D = Record
        PosX,
        PosY,
        PosZ,
        NouveauX,
        NouveauY,
        EtoileX,
        EtoileY :Integer;
    End;
    TMaxEtoile = 1..MAX_ETOILE;
    TTabStarField3D = Array[TMaxEtoile] of TStarFiel3D;  {100 toiles  grer}

Var
  Form1: TForm1;             {Variable reprsentant la fentre}
  StarField :TTabStarField3D;{Notre objet StarFied et ses mthodes, proprites}
  TouchePresser :Boolean;    {Si une touche est press alors fermer le prog}
  Vitesse :Integer;          {Vitesse de dfilement des toiles}
{******************************************************************************}

implementation
{$R *.DFM}

procedure TForm1.NouvelleEtoile( Index :Integer );

{Objectif :Cette fonction servira  crer un toile selon son index.
           Donc chaque fois qu'une toile auras fait son chemin  travers
           l'cran et sera rendu  l'extrmit, nous devrons lui attribuer
           une nouvelle place dans l'cran.}

Begin
  {Une nouvelle position alatoire pour les X}
    StarField[Index].PosX := Random(Form1.Width);
    Dec( StarField[Index].PosX, (Form1.Width Div 2) );

  {Une nouvelle position alatoire pour les Y}
    StarField[Index].PosY := Random(Form1.Height);
    Dec( StarField[Index].PosY, (Form1.Height Div 2) );

  {Remettre les valeurs des coordonnes [EtoileX, EtoileY]  0}
    StarField[Index].EtoileX := 0;
    StarField[Index].EtoileY := 0;

  {Remettre la position des Z dans le centre [Milieu] de l'cran}
    StarField[Index].PosZ := 256;
End;

procedure TForm1.AfficherLesEtoiles;
{Ici nous afficherons les toiles et les feront animes  l'aide de cette
 formule
        PointX = ((PointX * 256) / PositionZ) + (EcranX / 2)
        PointY = ((PointY * 256) / PositoinZ) + (EcranY / 2)
      
}
Var
 {Variable contrle pour la LOOP FOR}
    I :Integer;

{Dimmension de L'cran}
    _Width, _Height :Word;

Begin

{Initialiser les dimensions de l'cran}
    _Width := Form1.Width;
    _Height := Form1.Height;

 {Animation des pixels...}
    For I := Low(StarField) To High(StarField) Do
    Begin
         {Si Z est dpass l'cran alors crer une nouvelle toile}
            If StarField[I].PosZ <= 0 Then NouvelleEtoile(I);

            {Calculer la nouvelle position des toiles}
               StarField[I].EtoileX := ( (StarField[I].PosX Shl 8) Div StarField[I].PosZ) + _Width Div 2;
               StarField[I].EtoileY := ( (StarField[I].PosY Shl 8) Div StarField[I].PosZ) + _Height Div 2;

            {Dcrmenter la valeur de Z [Profondeur]}
               Dec( StarField[I].PosZ , Vitesse );

            {Revrifier encore si la profondeur est dj  0 avant le calcul des points
             en retard qui servent  produire un ligne.}
            If StarField[I].PosZ <= 0 Then  NouvelleEtoile(I);

             {Maintenant que la profondeur est dcrmenter, la position des points d'effaement
              sera calculs en retard sur le Z des premires pour former une ligne blanche de la longueur du Z}
               StarField[I].NouveauX := ( (StarField[I].PosX Shl 8) Div StarField[I].PosZ) + _Width Div 2;
               StarField[I].NouveauY := ( (StarField[I].PosY Shl 8) Div StarField[I].PosZ) + _Height Div 2;

           {Vrifier si la ligne  dpasser l'cran, si oui alors crer une nouvelle
           'toiles sinon, afficher la ligne qui avancera toujours vers vous avec le
           'profondeur qui se dcrmente de 4  chaque passage de la LOOP.
           'Donc :
           '      Si la ligne (X, Y) est plus grande que l'cran alors crer une nouvelle toile
           '      Par contre si par malchance la position du (X, Y) choisi alatoirement  travers l'cran
           '      pas acceptable pour la formule (Erreur : division par 0) alors on se doit de recrer une
           '       nouvelle toile
           }
            If (StarField[I].NouveauX > _Width) Or (StarField[I].NouveauY > _Height) Or
               (StarField[I].NouveauX <= 0) Or (StarField[I].NouveauY <= 0) Then
               NouvelleEtoile(I)

            Else
            Begin
                 Form1.Canvas.Pen.Color := RGB(255 + (I * -2), 255 + (I * -2), 255 + (I * -2));
                 Form1.Canvas.MoveTo(StarField[I].EtoileX, StarField[I].EtoileY);
                 Form1.Canvas.LineTo(StarField[I].NouveauX, StarField[I].NouveauY);
            End;
    End;
End;

procedure TForm1.FormActivate(Sender: TObject);

{Objectif : Crer nos 100 toiles  l'aide d'une LOOP qui touchera aux
            proprites de chaque toiles.}

Var
   {Variable contrle}
    I :Integer;

begin
   {Agrandir la form au maximum}
     Form1.WindowState := wsMaximized;

    {Initialiser le gnrateur de nombre alatoire}
      Randomize;

    {Crer toutes les toiles  l'aide d'une LOOP et de la procdure
     NouvelleEtoile.}
      For I := Low(StarField) To High(StarField) Do
          NouvelleEtoile(I);

    {Ajuster la vitesse (Par dfaut)}
     Vitesse := 4;

    {Cacher le curseur de la souris}
    ShowCursor( FALSE );

    {Dmarrer le Champ d'toiles}
    While TouchePresser <> True Do
    Begin
         Form1.Canvas.Pen.Color := ClBlack;
         Form1.Canvas.FillRect( Rect(0 ,0 ,Form1.Width, Form1.Height) );
         Application.ProcessMessages;
         AfficherLesEtoiles;
    End;

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

{Objectif :Si la touche ESCAPE est est presse, alors rafficher le curseur de
           la souris et mettre fin au programme.
           Sinon, si la touche UP du clavier est presse alors faire dfiler
           le champ d'toile plus rapidement et le contraire pour le touche
           Down.}

begin
     Case Ord(Key) Of
     {Touche Escape}
       27:Begin
               TouchePresser := True;
               ShowCursor( TRUE );
               Close;
          End;

     {Touche vers le haut}
       38:If Vitesse <= VITESSE_MAX Then
               Inc( Vitesse, 1 );


     {Touche vers le bas}
       40:If Vitesse > VITESSE_MIN Then
             Dec( Vitesse, 1 );
     End;

end;

end.
